=== debian/changelog ===
hhvm (3.21.0+dfsg-2ubuntu2) bionic; urgency=medium

  * Build-depend on libcurl4-gnutls-dev instead, which is the default
    implementation and lets us continue building against libssl1.0-dev, as
    the source is not OpenSSL 1.1-compatible.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 28 Feb 2018 22:06:09 +0000

hhvm (3.21.0+dfsg-2ubuntu1) bionic; urgency=medium

  * Build-depend on libssl-dev again instead of libssl1.0-dev and re-add
    build-dependency on libc-client2007e-dev.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 28 Feb 2018 21:17:58 +0000

hhvm (3.21.0+dfsg-2build5) bionic; urgency=medium

  * No-change rebuild against libcurl4

 -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 28 Feb 2018 06:56:58 +0000

hhvm (3.21.0+dfsg-2build4) bionic; urgency=medium

  * No change rebuild against libre2-4.

 -- Stefano Rivera <stefanor@ubuntu.com>  Fri, 23 Feb 2018 15:07:17 -0800

hhvm (3.21.0+dfsg-2build3) bionic; urgency=high

  * No change rebuild against openssl1.1.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 06 Feb 2018 12:42:49 +0000

hhvm (3.21.0+dfsg-2build2) bionic; urgency=medium

  * No-change rebuild for icu soname change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 07 Nov 2017 08:52:54 +0000

hhvm (3.21.0+dfsg-2build1) bionic; urgency=medium

  * No-change rebuild for libicu soname change.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 25 Oct 2017 15:40:34 +0000

hhvm (3.21.0+dfsg-2) unstable; urgency=medium

  * Fix compatibility with glibc 2.26, thanks to Matthias Klose for
    the report (Closes: #875904)

 -- Moritz Muehlenhoff <jmm@debian.org>  Wed, 27 Sep 2017 16:25:21 +0200

hhvm (3.21.0+dfsg-1) unstable; urgency=medium

  * New upstream release 3.21 (3.18 releases were not
    uploaded to the archive due to various stability
    problems)
  * Fix FTBFS with GCC 7 (Closes: #853442)
  * Back out broken upstream JSON test case (reported at
    https://github.com/facebook/hhvm/issues/7708)
  * Add ocamlbuild to build dependencies (reported in #868480,
    compatibility of 3.21 with ocaml 4.05 needs to be revisited)
  * Update copyright file for 3.12->3.21 period, taking most of
    the entries for webscalesqlclient from src:mysql-5.6's copyright
    file
  * Remove Upstart job
  * Bump standards version

 -- Moritz Muehlenhoff <jmm@debian.org>  Mon, 07 Aug 2017 21:55:59 +0200

hhvm (3.18.1+dfsg-1) unstable; urgency=medium

  [ Faidon Liambotis ]
  * New upstream release 3.17.0+dfsg
  * Remove patches merged upstream:
    - libc6-223-isnan.patch
    - gcc6.patch
    - disable-folly-fibers.patch
    - pcre-838-limits.patch
    - pcre-disable-limit-test.patch
    - mysqlclient-r.patch
    - fix_stats_error.patch
    - output-buffer-fix-flush.patch
    - revert-unbreak-jsonc.patch
    - icu-getsortkey.patch
    - bzip2-segfault-sweep.patch
    - reproducible-proxygen-header.patch
  * Remove patches for code that was reworked upstream:
    - reproducible-hack-builddate.patch
    - reproducible-hack-compilerid.patch
  * Depend on ragel:
    - Add ragel to Build-Depends.
    - Remove ragel from third-party when repacking (debian/repack)
    - Add patch use-system-ragel.patch.
  * Add new third-party bundles brotli and fatal to debian/copyright.
  * Re-enable the mcrouter extension as it should build again now.

  [ Moritz Muehlenhoff ]
  * New upstream release 3.18.1+dfsg
  * Add missing build-dependency on libkrb5-dev
  * Add a versioned dependeny on lz4 >= 130, the lz4 extension in 3.18
    uses the new LZ4_compress_default() function introduced there
  * No longer strip webscalesqlclient from dfsg tarball, with 3.18 the
    mysql extension requires it as well (transivitely via squangle,
    which in turn depends on webscalesql)
  * Add build dependency on libreadline-dev, required by webscalesqlclient
  * Reenable asynchronous MySQL support now that we're using webscalesqlclient
    again (even when adding webscalesqlclient back to the source try, squangle
    is only linked with DENABLE_ASYNC_MYSQL=ON, IOW DENABLE_ASYNC_MYSQL=OFF is
    entirely broken
  * Cherrypick f7a1dae3d90179c10c03e749875aa8a6a5015605 from upstream
    master to fix testsuite failure with DUSE_JSONC=ON
  * Run testsuite in LC_ALL=C.UTF-8, one of the tests is
    locale-sensitive (https://github.com/facebook/hhvm/issues/7708)
  * Cherrypick 5207b59eb88e2f9820efb74442245a4f5aa9eb17 from upstream
    master to fix crashes with hhvm.server.stat_cache enabled
  * Add myself to Uploaders

 -- Moritz Muehlenhoff <mmuhlenhoff@wikimedia.org>  Wed, 05 Apr 2017 09:46:19 +0200
