=== debian/watch ===
version=3
opts=dversionmangle=s/\+dfsg.*$//,\
filenamemangle=s/(?:.*)?v?HHVM-(\d[\d\.]*)\.tar\.gz/hhvm-$1.tar.gz/ \
  https://github.com/facebook/hhvm/tags \
  (?:.*/)?v?HHVM-(\d[\d\.]*)\.tar\.gz
